/**
 * Demonstrates quickly 
 * switching textures, which
 * cover a square mesh.
 * 
 * @param {String} s1 path
 * to an image file.
 * @param  {String} s2 path
 * to a second image file.
 */
var GLChangeTexture = function(
 s0, 
 s1
)
{
	
if (typeof Float32Array === 'undefined'){
 
	new Controller(
  0,
  null,
  null,
  null
 );

 return;

}

this.numberTexture = Number(0); 

var square = new Square(); 

var arySprites = new Array();  

// First texture
// unit TEXTURE0
var n = new Sprite(
 s0,
 0,
 square.aOffset[0],
 square.aCount[0]
);

arySprites.push(n);

// Second texture
// unit TEXTURE1.
n = new Sprite(
 s1,
 1,
 null,
 null
);

arySprites.push(n);  

var controller = new Controller
(
 square.aVertices,
 square.aIndices,  
 arySprites,
 this
);
 
this.setListener(
 controller
);
  
return this;

}

GLChangeTexture.prototype = {    

/**
 * Assign button event
 * listener to change
 * textures.
 * @param {Controller}
 */
setListener: function(controller){

 var btnChange = document.getElementById(
  "btnChange"
 );
 
 btnChange.controller = controller;

 btnChange.addEventListener
 (
  'click',   
  this.changeTexture,   
  false
 ); 
},

/**
 * Change the texture
 * which maps the sprite.
 * @param {EventObject) ev.
 */
changeTexture: function(ev){
	
 var controller = ev.currentTarget.controller;
 
 var glDemo = controller.glDemo;
 
 var sprite = controller.aSprites[0];
 
 var gl = controller.gl; 

 if (glDemo.numberTexture == 0){  
	 glDemo.numberTexture = Number(1);
 }
 else{   
	 glDemo.numberTexture = Number(0);
 }

 gl.uniform1i
 (
	 sprite.uSampler, 
	 glDemo.numberTexture
 ); 

 glDemo.render(
	 controller
 );
     
},

/**
 * Render the sprite.
 * @param {Controller}
 */
render:function(
	 controller
	)
	{
		
	var gl = controller.gl;
	
 var sprite = controller.aSprites[0];
 
	gl.uniformMatrix4fv
	(
	 controller.uMatrixTransform, 
	 gl.FALSE, 
	 sprite.matrix
	);

	gl.drawElements
	(
	 gl.TRIANGLES, 
	 sprite.nCount, 
	 gl.UNSIGNED_SHORT, 
	 sprite.nOffset
	);

},

}