/**
 * Repeat a Texture
 * across a square
 * with WebGL.
 * @param {String} s
 * path to image file.
 */
var GLSquareRepeat = function(s){
	
if (typeof Float32Array === 'undefined'){
 new GLControl(
  0,
  null,
  null,
  null
 );
 return;
}
	
var square = new SquareRepeat();
 
var n = new Sprite(
 s,
 0,
 square.aOffset[0],
 square.aCount[0]
);

var aSprites = new Array();
aSprites.push(n);

var controller = new Controller
(
 square.aVertices,
 square.aIndices, 
 aSprites,
 this
);
}

/*
 * Prototype 'class'
 * for repeating
 * images on a texture.
 */
GLSquareRepeat.prototype = {
		
/*
 * Method init()
 * Initialize active
 * texture's wrap modes.
 * @param {Controller}
 */
init: function (controller){
	
var gl = controller.gl;

// Repeat the horizontal texel
// along edges of defined polygons.
gl.texParameteri
(
 gl.TEXTURE_2D,
 gl.TEXTURE_WRAP_S,
 gl.REPEAT
);

//Repeat the vertical texel
//along edges of defined polygons.
gl.texParameteri
(
 gl.TEXTURE_2D,
 gl.TEXTURE_WRAP_T,
 gl.REPEAT
); 
},  

/**
 * Render the sprite.
 * @param {Controller}
 */
render:function(
 controller
)
{
	
	var sprite = controller.aSprites[0];	
	
	var gl = controller.gl;

	gl.uniformMatrix4fv
	(
	 controller.uMatrixTransform, 
	 gl.FALSE, 
	 sprite.matrix
	);

	gl.drawElements
	(
	 gl.TRIANGLES, 
	 sprite.nCount, 
	 gl.UNSIGNED_SHORT, 
	 sprite.nOffset
	);

	},
} //End Prototype