/**
 * Interactively
 * rotate a WebGL square
 * mesh. 
 * GLSquareRotate constructor.
 * @param {String} s
 * path
 * to an image file.
 */
var GLSquareRotate = function(s){
	
if (typeof Float32Array === 'undefined'){
 new Controller(0,null,null,null);
 return;
}
	
var square = new Square();
	
var sprite =  new Sprite(
 s,
 0,
 square.aOffset[0],
 square.aCount[0]
);
	
var arySprites = new Array();
arySprites.push(sprite);
	
var controller = new Controller
(
square.aVertices,
square.aIndices,  
arySprites,
this
); 
};

GLSquareRotate.prototype = {
		
/** 
* Create a reference
* of type 'Responsive'.
* @param {Controller}
*/
init:function(
 controller
)
{
	
 var responsive = new Responsive(
  controller,
  null
 );

 if (responsive == null){
  controller.eDebug.innerHTML = "Responsive == null";
 }
},

/** 
* Interactive rendering.
* Rotate the sprite
* along the horizontal
* or vertical axis
* in response to mouse
* or touch movement.
* @param {Controller}
*/
render: function(controller){
		
		var sprite = controller.aSprites[0];

		var gl = controller.gl;

		var glDemo = controller.glDemo;

		//Create 4x4 matrix 
		//to represent the
		//user's viewpoint.
		var matrixView = mat4.create();

		//Copy the
		//sprite's
		//matrix for
		//an upload matrix,
		//X, and Y rotation matrices.
		mat4.set(
		 sprite.matrix,
		 matrixView
		);

			
		var pX = glDemo.nX;

		var pY = glDemo.nY;

		var nDiv = glDemo.nDiv;

		var rY = pX * nDiv;

		var rX = pY * nDiv;
		 
		mat4.rotate(
		 matrixView, 
		 rX, 
		 [1, 0, 0]
		);

		mat4.rotate(
			matrixView, 
			rY, 
			[0, 1, 0]
		);

		gl.uniformMatrix4fv
		(
		 controller.uMatrixTransform, 
		 false, 
		 new Float32Array
		 (
		  matrixView
		 )
		); 

		gl.drawElements
		(
		 gl.TRIANGLES, 
		 sprite.nCount, 
		 gl.UNSIGNED_SHORT, 
		 sprite.nOffset
		); 
		 
},

};